<template>
  <div class="main-container">
    <span v-if="!savedUsername"></span>
    <div v-else class="center">
      <h1 class="c-username">{{ savedUsername }}</h1>
    </div>
    <input class="input-clean" v-if="!savedUsername" v-model="username" placeholder="Agrega tu username"
      @keyup.enter="addUsername" />
    <div class="buttons">
      <button v-if="!savedUsername" @click="addUsername">Entrar</button>
      <button v-else @click="clearUsername" class="clear-button">Remover username</button>
    </div>
  </div>
</template>

<script>
import { createSocket, getSocket } from '../plugins/socket';
import EventBus from '../plugins/event-bus';

export default {
  data() {
    return {
      username: '',
      savedUsername: '',
    };
  },
  created() {
    const savedUsername = localStorage.getItem('username');
    if (savedUsername) {
      this.savedUsername = savedUsername;
      this.addUsername(true);
    }
  },
  methods: {
    addUsername(initialLoad = false) {
      if (!initialLoad && this.username.trim() === '') {
        alert('Username cannot be empty!');
        return;
      }

      this.savedUsername = this.username || this.savedUsername;
      createSocket(this.savedUsername);
      localStorage.setItem('username', this.savedUsername);
      EventBus.emit('usernameAdded', this.savedUsername);
    },
    clearUsername() {
      const confirmed = confirm('Are you sure you want to clear the username?');
      if (confirmed) {
        this.username = '';
        this.savedUsername = '';
        localStorage.removeItem('username');
        const socket = getSocket();
        if (socket) {
          socket.disconnect();
        }
        EventBus.emit('usernameCleared');
      }
    },
  },
};
</script>

<style scoped>
.main-container {
  display: flex;
  flex-direction: column;
  align-items: center;
  padding: 20px 0;
  margin-bottom: 20px;
  background-color: rgb(23, 23, 23);
  border-radius: 10px;
  box-shadow: 0 0 10px rgb(155, 155, 155);
  width: 70vw;
}

.c-title {
  color: #fff;
}

.c-username {
  color: #00a2d7;
}

.center {
  text-align: center;
}

.buttons {
  display: flex;
  justify-content: center;
  width: 100%;
}

.input-clean {
  width: 100%;
  padding: 10px;
  margin: 5px 0;
  border: 1px solid #ccc;
  border-radius: 5px;
  box-sizing: border-box;
  background: transparent;
  border: none;
  text-align: center;
  height: 70px;
  color: white;
}

button.clear-button {
  background-color: #ff3b30;
}

button.clear-button:hover {
  background-color: #d32f2f;
}
</style>